love.graphics.setBackgroundColor(1, 1, 1)
maps = {{},{},{},{},{}}
require("maps")
local player = {x = 0, y = 0}
local menu = 1
local map
local menuButtons = {}
local music = {}
local images = {}
local fontSize = {}
for i = 1, 100 do
  fontSize[i] = love.graphics.newFont(i)
end
function player:update()
  if self.left then self.x = self.x - 5 end
  if self.right then self.x = self.x + 5 end
  if self.up then self.y = self.y - 5 end
  if self.down then self.y = self.y + 5 end
end
function isInside(x, y, w, h, X, Y)
  if X > x and X < x + w and Y > y and Y < y + h then return true end
  return false
end
function newMenuButton(x, y, w, h, inMenu, lable, toScene)
  local button = {x = x, y = y, w = w, h = h, inMenu = inMenu, lable = lable, toScene}
  menuButtons[#menuButtons + 1] = button
  function draw(self)
    if menu == self.inMenu then
      love.graphics.setFont(fontSize[30])
      love.graphics.setColor(0.5, 0.5, 1)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
      love.graphics.setColor(0, 0, 0)
      love.graphics.printf(self.lable, self.x, self.y + self.h/3 ,self.w, "center")
    end
  end
  function clicked(self, X, Y)
    if menu == self.inMenu and isInside(self.x, self.y, self.w, self.h, X, Y) then
      if toScene[1] == 0 then
        if menu >= 2 then
          startGame(maps[inMenu][toScene[2]])
        end
      end
      menu = toScene[1]
      return true
    end
    return false
  end
  button.draw = draw
  button.clicked = clicked
end
newMenuButton(50, 50, 700, 100, 1, "levels", {2})
newMenuButton(50, 50, 100, 100, 2, 1, {0, 1})
newMenuButton(200, 50, 100, 100, 2, 2, {0, 2})
newMenuButton(350, 50, 100, 100, 2, 3, {0, 3})
newMenuButton(500, 50, 100, 100, 2, 4, {0, 4})
newMenuButton(650, 50, 100, 100, 2, 5, {0, 5})
newMenuButton(50, 200, 700, 100, 1, "maps", {3})
newMenuButton(50, 50, 100, 100, 3, 1, {0, 1})
newMenuButton(200, 50, 100, 100, 3, 2, {0, 2})
newMenuButton(350, 50, 100, 100, 3, 3, {0, 3})
function love.draw()
  if menu > 0 then
    for i = 1, #menuButtons do
      menuButtons[i]:draw()
    end
  elseif menu == 0 then
    map:draw()
  end
end
function love.update()
  if menu == 0 then
    map:update()
    player:update()
  end
end
function love.mousepressed(x, y, button)
  for i = 1, #menuButtons do
    if menuButtons[i]:clicked(x, y) then return end
  end
  if menu == 0 then
    for i = 1, #map.items do
      if map.items[i]:clicked(x, y, button) then
        if map.items[i][1] and (map.items[i].x <= 0 or map.items[i].x + map.items[i].l >= map.width or map.items[i].y <= 0 or map.items[i].y + map.items[i].l >= #map / map.width) then
          clean()
        end
        return
      end
    end
  end
end
function love.keypressed(k)
  if k == "p" then clean() end
  if k == "up" then player.up = true
  elseif k == "down" then player.down = true
  elseif k == "left" then player.left = true
  elseif k == "right" then player.right = true
  end
end
function love.keyreleased(k)
  if k == "up" then player.up = false
  elseif k == "down" then player.down = false
  elseif k == "left" then player.left = false
  elseif k == "right" then player.right = false
  end
end
function startGame(Map)
  map = instMap(Map)
end
function instMap(Map)
  local instance = {items = {}}
  instance.width = Map.width
  for i = 1, #Map do
    instance[i] = Map[i]
  end
  for i = 1, #Map.items do
    instance.items[i] = {}
    instance.items[i].dir = Map.items[i].dir
    instance.items[i].x = Map.items[i].x
    instance.items[i].y = Map.items[i].y
    instance.items[i].drawX = Map.items[i].x * 40
    instance.items[i].drawY = Map.items[i].y * 40
    instance.items[i].l = Map.items[i].l
    instance.items[i][1] = Map.items[i][1]
    instance.items[i].parent = instance
    function draw(self)
      if self[1] then
        love.graphics.setColor(1, 0.1, 0.1)
      else
        love.graphics.setColor(0.8, 0.3, 0.5)
      end
      if self.dir == 1 then
        love.graphics.rectangle("fill", self.drawX+40 - player.x, self.drawY - player.y, 40*self.l-1, 39)
      elseif self.dir == 2 then
        love.graphics.rectangle("fill", self.drawX+40 - player.x, self.drawY - player.y, 39, 40*self.l-1)
      end
    end
    function clicked(self, x, y, button)
      if self.dir == 1 then
        if isInside(40*(self.x + 1) - player.x, 40*self.y - player.y, 39, 39, x, y) and self.parent[self.y*self.parent.width + self.x] == 0 then
          self.x = self.x - 1
          self.animation = "left"
          return true
        elseif isInside(40*(self.x + self.l) - player.x, 40*self.y - player.y, 39, 39, x, y) and self.parent[self.y*self.parent.width + self.x + 1 + self.l] == 0 then
          self.x = self.x + 1
          self.animation = "right"
          return true
        end
      elseif self.dir == 2 then
        if isInside(40*(self.x + 1) - player.x, 40*self.y - player.y, 39, 39, x, y) and self.parent[(self.y-1)*self.parent.width + self.x + 1] == 0 then
          self.y = self.y - 1
          self.animation = "up"
          return true
        elseif isInside(40*(self.x + 1) - player.x, 40*(self.y + self.l - 1) - player.y, 39, 39, x, y) and self.parent[(self.y+self.l)*self.parent.width + self.x + 1] == 0 then
          self.y = self.y + 1
          self.animation = "down"
          return true
        end
      end
      return false
    end
    function update(self)
      if self.animation == "left" then
        self.drawX = self.drawX - 5
        if self.drawX % 40 == 0 then self.animation = nil end
      elseif self.animation == "right" then
        self.drawX = self.drawX + 5
        if self.drawX % 40 == 0 then self.animation = nil end
      elseif self.animation == "up" then
        self.drawY = self.drawY - 5
        if self.drawY % 40 == 0 then self.animation = nil end
      elseif self.animation == "down" then
        self.drawY = self.drawY + 5
        if self.drawY % 40 == 0 then self.animation = nil end
      end
    end
    instance.items[i].draw = draw
    instance.items[i].clicked = clicked
    instance.items[i].update = update
  end
  function draw(self)
    for y = 0, #self / self.width - 1 do
      for x = 1, self.width do
        local grid = self[self.width*y + x]
        if grid == 5 then
          love.graphics.setColor(0, 0, 0)
          love.graphics.rectangle("fill", x*40 - player.x, y*40 - player.y, 40, 40)
        end
      end
    end
    for i = 1, #self.items do
      self.items[i]:draw()
    end
  end
  function update(self)
    for i = 1, #self do
      if self[i] ~= 5 then self[i] = 0 end
    end
    for i = 1, #self do
      for j = 1, #self.items do
        if self.items[j].y*self.width + self.items[j].x+1 == i then
          if self.items[j].dir == 1 then
            for k = i, i + self.items[j].l - 1 do
              self[k] = 1
            end
          elseif self.items[j].dir == 2 then
            for k = i, i + (self.items[j].l - 1)*self.width, self.width do
              self[k] = 1
            end
          end
        end
      end
    end
    for i = 1, #self.items do
      self.items[i]:update()
    end
  end
  instance.draw = draw
  instance.update = update
  return instance
end
function clean()
  player.x = 0
  player.y = 0
  map = nil
  menu = 1
end